﻿Imports System.Collections.ObjectModel

Namespace ViewModel
    Public Class MainWorkspaceViewModel
        Inherits ViewModelBase

        Public Sub New()
            Cars = New ObservableCollection(Of CarViewModel)
            Cars.Add(New CarViewModel("VW", "Golf GTI", 230, New List(Of EquipmentViewModel) From {
                                      New EquipmentViewModel("ACC", "Abstandstempomat", 899),
                                      New EquipmentViewModel("Navigationssystem", "Navigationssystem 'Discovery' mit Livetimeupdate", 1500),
                                      New EquipmentViewModel("LED Scheinwerfer", "Voll LED Scheinwerfer mit automatischer Niveauregulierung", 450)}))

            Cars.Add(New CarViewModel("Seat", "Ibiza FR", 110, New List(Of EquipmentViewModel) From {
                                      New EquipmentViewModel("Navigationssystem", "Navigationssystem 'Discovery' mit Livetimeupdate", 499),
                                      New EquipmentViewModel("Sitzheizung", "Sitzheitzung für Fahrer und Beifahrer", 300)}))

        End Sub

        Dim _cars As ObservableCollection(Of CarViewModel)
        Public Property Cars As ObservableCollection(Of CarViewModel)
            Get
                Return _cars
            End Get
            Set
                _cars = Value
                RaisePropertyChanged()
            End Set
        End Property

        Private _selectedCar As CarViewModel
        Public Property SelectedCar As CarViewModel
            Get
                Return _selectedCar
            End Get
            Set(ByVal value As CarViewModel)
                _selectedCar = Value
                RaisePropertyChanged()
            End Set
        End Property


        Private _deleteCarCommand As ICommand
        Public Property DeleteCarCommand As ICommand
            Get
                If _deleteCarCommand Is Nothing Then _deleteCarCommand = New RelayCommand(AddressOf Delete_Execute, AddressOf Delete_CanExecute)
                Return _deleteCarCommand
            End Get
            Set(ByVal value As ICommand)
                _deleteCarCommand = Value
                RaisePropertyChanged()
            End Set
        End Property
        Private Function Delete_CanExecute(ByVal obj As Object) As Boolean
            Return obj IsNot Nothing AndAlso obj.GetType Is GetType(CarViewModel)
        End Function
        Private Sub Delete_Execute(ByVal obj As Object)
            Cars.Remove(CType(obj, CarViewModel))
        End Sub

    End Class
End Namespace
